## GstDmaBufAllocator GstDmaBufAllocator — Memory wrapper for Linux dmabuf memory |

## Functions

GstAllocator * | gst_dmabuf_allocator_new ()
GstMemory * | gst_dmabuf_allocator_alloc ()
gint | gst_dmabuf_memory_get_fd ()
GType | gst_dmabuf_allocator_get_type ()
gboolean | gst_is_dmabuf_memory ()

## Types and Values

#define | GST_CAPS_FEATURE_MEMORY_DMABUF

## Includes

    #include <gst/allocators/gstdmabuf.h>

## Description

## Functions

### gst_dmabuf_allocator_new ()

    GstAllocator *
    gst_dmabuf_allocator_new (void);

Return a new dmabuf allocator.

#### Returns

a new dmabuf allocator, or NULL if the allocator isn't available. Use `gst_object_unref()` to release the allocator after usage.

[transfer full]

Since: 1.2

### gst_dmabuf_allocator_alloc ()

    GstMemory *
    gst_dmabuf_allocator_alloc (GstAllocator *allocator,
                                gint fd,
                                gsize size);

Return a `GstMemory` that wraps a dmabuf file descriptor.

#### Parameters

allocator | allocator to be used for this memory |
fd | dmabuf file descriptor |
size | memory size |

#### Returns

a GstMemory based on `allocator` . When the buffer will be released dmabuf allocator will close the `fd` . The memory is only mmapped on `gst_buffer_mmap()` request.

[transfer full]

Since: 1.2

### gst_dmabuf_memory_get_fd ()

    gint
    gst_dmabuf_memory_get_fd (GstMemory *mem);

Return the file descriptor associated with `mem` .

#### Parameters

mem | the memory to get the file descriptor |

#### Returns

the file descriptor associated with the memory, or -1. The file descriptor is still owned by the GstMemory. Use dup to take a copy if you intend to use it beyond the lifetime of this GstMemory.

Since: 1.2

### gst_dmabuf_allocator_get_type ()

    GType
    gst_dmabuf_allocator_get_type (void);

### gst_is_dmabuf_memory ()

    gboolean
    gst_is_dmabuf_memory (GstMemory *mem);

Check if `mem` is dmabuf memory.

#### Parameters

mem | the memory to be check |

#### Returns

`TRUE` if `mem` is dmabuf memory, otherwise `FALSE`

Since: 1.2

## Types and Values

### GST_CAPS_FEATURE_MEMORY_DMABUF

    #define GST_CAPS_FEATURE_MEMORY_DMABUF "memory:DMABuf"

Constant that defines the caps feature name for DMA buffer sharing.

It has to be used for non-mappable dma-buf only, i.e. when the underlying memory is not mappable to user space. Or when the mapped memory contains non meaningful data. It can be the case for protected content or when the user wants explicitly avoid any software post processing.

In these cases all elements between the exported and the importer has to work in passthrough mode. This is done by adding this caps feature.

When the memory is mappable for read and write requests then it is assumes to be a fast path and so this caps feature should not be used. Though according to the dma-buf protocal, while it is mapped it prevents the exporter to migrate the buffer.

This caps feature should not serve at all the purpose of selecting the `GST_ALLOCATOR_DMABUF` allocator during caps negotiation. When the exporter is the upstream element from the importer point of view, the exporter should try to map the dma buffer at runtime (preferrably during decide_allocation phase). When it succeeds for GST_MAP_READWRITE this caps feature should not be used. This allows scalers, color converts and any image processing filters to work directly on the dma buffer. In this case the importer element should check all incomming memory using `gst_is_dmabuf_memory()`.

Since: 1.11

## See Also

GstMemory